local luacom = require('luacom')

local function trace(a,b,c,d) return end

local msmq = {}

msmq.queue = {
   PathName = '.\\PRIVATE$\\845f119e-b8de-490d-8165-144e5e99a404',
   Label = 'iNTERFACEWARE LuaCOM MSMQ Example',
}

local function ExportConstants()
   local const = {}
   local QInfo = luacom.CreateObject('MSMQ.MSMQQueueInfo.1')
   assert(QInfo)

   luacom.ExportConstants(QInfo, const)
   return const
end

msmq.const = ExportConstants()

function msmq.open(Access, ShareMode, Params)
   local QInfo = luacom.CreateObject('MSMQ.MSMQQueueInfo.1')

   Params = Params or msmq.queue
   QInfo.PathName = Params.PathName
   QInfo.FormatName = Params.FormatName
   QInfo.Label = Params.Label
   
   local Success, Queue = pcall(function() return QInfo:Open(Access, ShareMode) end)
   if not Success then
      pcall(function() QInfo:Create() end)
      return QInfo:Open(Access, ShareMode) 
   else
      return Queue
   end
end

function msmq.send(Data, Params)
   local Queue = msmq.open(msmq.const.MQ_SEND_ACCESS, msmq.const.MQ_DENY_NONE, Params)
   local Message = luacom.CreateObject('MSMQ.MSMQMessage.1')
   Message.Body = Data
   Message:Send(Queue)
end

function msmq.receive(Params)
   local Queue = msmq.open(msmq.const.MQ_RECEIVE_ACCESS, msmq.const.MQ_DENY_NONE, Params)
   
   local Transaction = msmq.const.MQ_NO_TRANSACTION
   local WantDestinationQueue = false
   local WantBody = true
   local ReceiveTimeout = 1000 -- ms
   local WantConnectorType = false
   
   local Message = Queue:Receive(Transaction, WantDestinationQueue, 
      WantBody, ReceiveTimeout, WantConnectorType)
   
   if Message then
      if Message.Body and Message.Body ~= '' then
         return Message.Body
      end
   end
end

return msmq